#ifndef _GAME_GUI_GLFW_H
#define _GAME_GUI_GLFW_H

#include "game-gui.hpp"

#ifdef GAMEGUI_INCLUDE_VULKAN
   #define GLFW_INCLUDE_VULKAN
#endif

#include <GLFW/glfw3.h>

class GameGui_GLFW : public GameGui {
   public:
      bool Init();
      void Shutdown();

      void* CreateWindow(const string& title, unsigned int width, unsigned int height);
      void DestroyWindow();

#ifdef GAMEGUI_INCLUDE_VULKAN
      bool CreateVulkanSurface(VkInstance instance, VkSurfaceKHR* surface);
#endif

      vector<const char*> GetRequiredExtensions();
      void GetWindowSize(int* width, int* height);

   private:
      GLFWwindow* window;
};

#endif // _GAME_GUI_GLFW_H